//===========================================================
// Header File 
//
// Copyright (C) 1995 Ziff-Davis Publishing Company
// First published in PC Magazine by Douglas Boling
//
//===========================================================
//-----------------------------------------------------------
// Generic defines and data types
//-----------------------------------------------------------
#if !defined(WIN32)
  #define WIN16     TRUE
  #define WIN31

  #define INT       int
  #define UINT      WORD
  #define APIENTRY  PASCAL
  #define WNDPROC   FARPROC
  
#else
  #define WIN16     FALSE

  //Macros to translate calls to new functions
  #define MoveTo(a, b, c) (MoveToEx ((a), (b), (c), NULL))
#endif

#define ODS(text) OutputDebugString (text)


#if !defined(MAX_PATH)
#define   MAX_PATH  256
#endif

// Returns no. of elements
#define dim(x) (sizeof(x) / sizeof(x[0]))   

struct decodeUINT {                         // structure associates
    UINT Code;                              // messages 
    LONG (*Fxn)(HWND, UINT, UINT, LONG);    // with a function
}; 
struct decodeCMD {                          // structure associates
    UINT Code;                              // menu IDs with a 
    LONG (*Fxn)(HWND, UINT, HWND, UINT);    // function
};

//
// Function prototypes used by generic template
//
INT  APIENTRY WinMain(HANDLE, HANDLE, LPSTR, INT);
LONG CALLBACK MainWndProc(HWND, UINT, UINT, LONG);
BOOL CALLBACK AddEditDlgProc (HWND, UINT, UINT, LONG);
BOOL CALLBACK AboutDlgProc (HWND, UINT, UINT, LONG);
BOOL CALLBACK AddEditDlgProc (HWND, UINT, UINT, LONG);

INT  InitApp(HANDLE);
INT  InitInstance(HANDLE, LPSTR, INT);
INT  TermInstance(HANDLE, INT);
INT  MyDisplayDialog (HINSTANCE, LPCSTR, HWND, WNDPROC, LPARAM);
BOOL MyWritePrivateProfileInt (char *, char *, int, char *);
WNDPROC MySubClassWindow (HWND, WNDPROC);
BOOL MyYield (void);
BOOL GetErrorString (INT, char *, INT);
void PrintError (HWND, INT);
LONG FileOps (HFILE *, INT, LONG, LONG, INT *);
INT  MyCtl3dStuff (HINSTANCE *, HINSTANCE, INT);
INT ParseCmdLine (LPSTR, LPSTR, DWORD *);
ATOM MyRegisterClass (WNDCLASS *);
INT PostWm_CommandMsg (HWND, WORD, WORD, HWND);

BOOL MyGetFilename (HWND, LPSTR, INT, DWORD, LPSTR, INT);
//
// Program specific prototypes
//
// Message handler functions
LONG DoCreateMain (HWND, UINT, UINT, LONG);
LONG DoShowWindowMain (HWND, UINT, UINT, LONG);
LONG DoDestroyMain (HWND, UINT, UINT, LONG);
LONG DoCommandMain (HWND, UINT, UINT, LONG);
// Control function Prototypes
LONG DoMainCtlNew (HWND, UINT, HWND, UINT);
LONG DoMainCtlOpen (HWND, UINT, HWND, UINT);
LONG DoMainCtlCut (HWND, UINT, HWND, UINT);
LONG DoMainCtlSetDefault (HWND, UINT, HWND, UINT);
LONG DoMainCtlAllFiles (HWND, UINT, HWND, UINT);
LONG DoMainCtlUnknown (HWND, UINT, HWND, UINT);
LONG DoMainCtlTypeFiles (HWND, UINT, HWND, UINT);
LONG DoMainCtlTypeList (HWND, UINT, HWND, UINT);
LONG DoMainCtlMenuList (HWND, UINT, HWND, UINT);
LONG DoMainCtlExit (HWND, UINT, HWND, UINT);
LONG DoMainCtlAbout (HWND, UINT, HWND, UINT);

//
// Defines used by generic routines in program
//
#define FOP_OPEN             1 
#define FOP_READ             2 
#define FOP_WRITE            3 
#define FOP_SEEK             4 
#define FOP_CLOSE            5 
#define FOP_FIND             6 

#define SFLAG_INIT           0x0001 
#define SFLAG_PRINTONLY      0x0002 

#define CTL3D_INIT           1
#define CTL3D_TERM           2

//
// Error numbers
//
#define	ERR_SYNTAX              -1
#define	ERR_OUT_OF_MEMORY       -2
#define	ERR_FILEREAD            -3
#define	ERR_FILEWRITE           -4
#define	ERR_FILESEEK            -5

// Error nums: -64 to -249 are file open error codes
#define	ERR_FOPEN_ERR           -63   //Err codes start at 1
#define	ERR_FILE_NOT_FOUND      -65
#define	ERR_PATH_NOT_FOUND      -66
#define	ERR_BADHANDLE           -69
#define	ERR_INVALID_DRIVE       -78

//
// Profile String Names
//
#define     PRO_XPOS      "WinPosX"
#define     PRO_YPOS      "WinPosY"
#define     PRO_XSIZE     "WinSizeX"
#define     PRO_YSIZE     "WinSizeY"

//
// Resource Idendifiers
//
/*
#define     IDM_NEW           10
#define     IDM_OPEN          11
#define     IDM_SAVE          12
#define     IDM_SAVEAS        13
#define     IDM_PRINT         14
#define     IDM_EXIT 	      15
#define     IDM_UNDO          20 
#define     IDM_CUT	          21
#define     IDM_COPY          22
#define     IDM_PASTE         23
#define     IDM_DELETE        24
#define     IDM_SELECTALL     25
#define     IDM_FIND          26
#define     IDM_FINDNEXT      27
#define     IDM_REPLACE       28
#define     IDM_ABOUT	      40
*/
#define     IDD_ABOUT1        600
#define     IDD_ABOUT2        601
#define     IDD_ABOUT3        602
#define     IDD_ABOUT4        603
#define     IDD_ABOUT5        604
#define     IDD_ABOUT6        605
#define     IDD_ABOUT7        606
#define     IDD_ABOUTLAST     607
#define     IDD_ALINE1        610
#define     IDD_ALINE2        611
#define     IDD_ALINE3        612
#define     IDD_ALINELAST     613
/*
//
//
//
#define     IDD_FILE          101
#define     IDD_ICON          102
#define     IDD_FICON         103
#define     IDD_FNAME         104
#define     IDD_TEXT1         105
#define     IDD_RA1           110
#define     IDD_RA2           111
#define     IDD_RI1           120
#define     IDD_RI2           121
#define     IDD_RI3           122
#define     IDD_RI4           123
#define     IDD_IC1           130
#define     IDD_IC2           131
#define     IDD_IC3           132
#define     IDD_IC4           133
#define     IDD_ABOUT         140
		    
*/		    


